<template>
  <div>
    <v-dialog
      v-model="dialog"
      persistent
      scrollable
      max-width="1000"
      attach="#app"
    >
      <v-card>
        <v-card-title
          class="pl-4 pr-1 py-1 text-subtitle-1 primary white--text"
        >
          {{ $t("tool.upload.title") }}
          <v-spacer />
          <GIconBtn
            :disabled="!dccIsLoaded"
            i18n="form.close"
            icon="mdi-close"
            small
            small-btn
            btn-class="theme--dark"
            @click="dialog = false"
          />
        </v-card-title>
        <v-card-text class="px-4 pt-1">
          <v-row>
            <v-col cols="7">
              <v-subheader>
                {{ $t("tool.upload.lastLoadedFiles.title") }}
                <v-spacer />
                <v-btn v-if="items.length" icon @click="clearLastLoadedFiles">
                  <v-icon>delete</v-icon>
                </v-btn>
              </v-subheader>
              <v-divider />
              <v-list
                two-line
                subheader
                style="overflow-x: auto; max-height: 28rem"
              >
                <template v-if="items.length">
                  <v-tooltip v-for="item in items" :key="item.title" bottom>
                    <template #activator="{ on }">
                      <v-list-item v-on="on" @click="item.onClick">
                        <v-list-item-avatar>
                          <v-icon>mdi-file</v-icon>
                        </v-list-item-avatar>

                        <v-list-item-content>
                          <v-list-item-title>
                            {{ item.title }}
                          </v-list-item-title>
                          <v-list-item-subtitle>
                            {{ item.subtitle }}
                          </v-list-item-subtitle>
                          <v-list-item-subtitle v-if="item.subtitle2">
                            {{ item.subtitle2 }}
                          </v-list-item-subtitle>
                        </v-list-item-content>

                        <v-list-item-action>
                          <v-btn
                            v-if="item.onRemove"
                            icon
                            @click.stop="item.onRemove"
                          >
                            <v-icon>mdi-close</v-icon>
                          </v-btn>
                        </v-list-item-action>
                      </v-list-item>
                    </template>
                    <span>{{ item.fullTitle }}</span>
                  </v-tooltip>
                </template>
              </v-list>
              <v-alert v-if="!items.length" type="info" outlined>
                {{ $t("tool.upload.lastLoadedFiles.empty") }}
              </v-alert>
            </v-col>
            <v-col cols="5">
              <v-btn class="mt-3" block color="success" @click="createNewDcc">
                <v-icon left>mdi-plus-box-outline</v-icon>
                {{ $t("tool.upload.create") }}
              </v-btn>
              <v-btn class="mt-4" block color="primary" @click="uploadClick">
                <v-icon left>mdi-open-in-app</v-icon>
                {{ $t("tool.upload.load") }}
              </v-btn>
              <div class="mt-5 mb-1" style="">
                {{ $t("tool.upload.gpTitle") }}:
              </div>
              <v-btn
                v-for="example of examples"
                :key="example.name"
                class="mt-4"
                block
                outlined
                color="grey darken-2"
                @click="createExampleDcc(example.name)"
              >
                <v-icon left>{{ example.icon }}</v-icon>
                {{ $t(`tool.upload.create${example.name}Example`) }}
              </v-btn>
            </v-col>
          </v-row>
          <v-row class="pb-0">
            <v-col cols="6">
              <v-alert type="info">
                {{ $t("tool.upload.schemaVersionHint") }}:
                {{ supportedSchemaVersionsHint }}
              </v-alert>
            </v-col>
            <v-col cols="6">
              <v-alert icon="warning" color="warning">
                {{ $t("tool.nonProductionWarning") }}
              </v-alert>
            </v-col>
          </v-row>
        </v-card-text>
      </v-card>
    </v-dialog>

    <v-dialog
      v-model="errorDialog"
      persistent
      scrollable
      max-width="1000"
      attach="#app"
    >
      <v-card>
        <v-card-title class="text-h5" primary-title>
          {{ $t("tool.upload.error.title") }}
        </v-card-title>

        <v-card-text>
          <v-expansion-panels>
            <v-expansion-panel v-for="(error, i) in errors" :key="i">
              <v-expansion-panel-header>
                <div>
                  {{ $t("tool.upload.error.line") }}: {{ error.line }} -
                  {{ error.type }}
                  {{
                    error.text
                      ? `-
                  ${error.text}`
                      : ""
                  }}
                </div>
              </v-expansion-panel-header>

              <v-expansion-panel-content>
                <h4 class="text-h5">
                  {{ $t("tool.upload.error.type") }}: {{ error.type }}
                </h4>
                <v-divider class="mb-3" />

                <h4 class="text-h5">
                  {{ $t("tool.upload.error.line") }}: {{ error.line }}
                </h4>
                <v-divider class="mb-3" />

                <h4 class="text-h5">{{ $t("tool.upload.error.text") }}</h4>
                <v-divider class="mb-3" />
                <pre>
                    <code class="d-block p-3 overflow-auto">{{ error.text }}<br/>{{error.fullText}}</code>
                </pre>
              </v-expansion-panel-content>
            </v-expansion-panel>
          </v-expansion-panels>
        </v-card-text>

        <v-card-actions>
          <v-spacer />
          <v-btn text @click="closeErrorDialog">
            {{ $t("form.ok") }}
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog
      v-model="unsupportedSchemaVersionDialog"
      persistent
      max-width="550"
    >
      <v-card>
        <v-card-title class="text-h5">
          {{ $t("tool.unsupportedSchemaVersionDialog.title") }}
        </v-card-title>
        <v-card-text>
          {{
            $t("tool.unsupportedSchemaVersionDialog.text", [
              dccSchemaVersion,
              supportedSchemaVersions.join(", "),
            ])
          }}
        </v-card-text>
        <v-card-actions>
          <v-btn color="green darken-1" text @click="closeErrorDialog">
            {{ $t("form.ok") }}
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <GIconBtn i18n="tool.upload.load" icon="mdi-cloud-upload" @click="show" />
  </div>
</template>

<script>
import { DCCDocument } from "@d-ptb/dcc-js";
import { compareDesc, format, formatDistance } from "date-fns";
import {
  latestSchemaLocation,
  supportedSchemaVersions,
  latestSchemaVersion,
} from "~/assets/util/constants";
import { createEmptyDcc } from "~/assets/util/dccUtil";
import { removeFromArray, timeout } from "~/assets/util/general";
import GIconBtn from "~/components/App/Common/GIconBtn";

export default {
  name: "AppDccUpload",
  components: { GIconBtn },
  props: {
    dccIsLoaded: Boolean,
  },
  data() {
    return {
      dialog: false,
      errorDialog: false,
      dccSchemaVersion: "",
      supportedSchemaVersions,
      unsupportedSchemaVersionDialog: false,
      errors: null,
      items: [],
      examples: [
        { name: "Temperature", icon: "mdi-thermometer" },
        // { name: "Air pressure", icon: "mdi-gauge" },
        { name: "Humidity", icon: "mdi-water" },
        // { name: "SiNat", icon: "mdi-circle" },
      ],
    };
  },
  computed: {
    supportedSchemaVersionsHint() {
      return `v${supportedSchemaVersions[0]} - v${latestSchemaVersion}`;
    },
  },
  created() {
    this.$tool.on("dccLoad", this.loadDCC);
  },
  beforeDestroy() {
    this.$tool.off("dccLoad", this.loadDCC);
  },
  async mounted() {
    await this.show();
  },
  methods: {
    async show() {
      this.$global.$emit("beforeUploadDialogShow");
      const lastFiles = (
        await this.$tool.storageStrategy.getLastLoadedItems()
      ).sort((a, b) => compareDesc(new Date(a.dateTime), new Date(b.dateTime)));
      this.items = [];

      for (const file of lastFiles) {
        this.items.push({
          title: file.fileName,
          fullTitle: file.filePath,
          subtitle: file.autoSave
            ? this.$t("tool.upload.lastLoadedFiles.autoSaveSubtitle")
            : null,
          subtitle2: formatDistance(new Date(file.dateTime), new Date(), {
            addSuffix: true,
          }),
          onClick: async () => {
            await this.loadDCC(file);
          },
          onRemove: async () => {
            if (!confirm(this.$t("tool.upload.lastLoadedFiles.confirmRemove")))
              return;

            await this.$tool.storageStrategy.removeLastLoadedItem(file);
            removeFromArray(
              this.items,
              this.items.find((x) => x.title === file.fileName)
            );
          },
        });
      }

      this.dialog = true;
    },
    async createNewDcc() {
      await this.loadDCCDoc(
        `${format(new Date(), "yyyy-MM-dd")}_dcc.xml`,
        createEmptyDcc()
      );
    },
    async createExampleDcc(quantity) {
      const xml = (await import(`~/assets/xml/gp/GP_${quantity}.xml`)).default;
      await this.loadDCCDoc(
        `${format(new Date(), "yyyy-MM-dd")}_GP_${quantity}.xml`,
        DCCDocument.fromXml(xml)
      );
    },
    async loadDCCDoc(newFileName, dccDocument) {
      this.dialog = false;
      this.$global.loadingDcc = true;
      await timeout(200);

      this.$tool.emit("dccLoaded", {
        newFileName,
        dccDocument,
      });
    },
    async uploadClick() {
      this.$global.loadingDcc = true;
      let file;
      try {
        file = await this.$tool.storageStrategy.promptLoad();
      } catch (e) {
        this.$notifier.error(e);
        this.$global.loadingDcc = false;
        return;
      }
      // check if the user has selected a file
      if (file) {
        await this.loadDCC(file);
      } else {
        this.$global.loadingDcc = false;
      }
    },
    async loadDCC(dccFile) {
      this.dialog = false;
      this.$global.loadingDcc = true;
      await timeout(200);

      // try to load file contents
      let xml;
      try {
        xml = await dccFile.load();
      } catch (e) {
        // show error, open dialog again and stop loading
        this.$notifier.error(e);
        this.dialog = true;
        this.$global.loadingDcc = false;
        return;
      }

      // check for schema version
      this.dccSchemaVersion = new DOMParser()
        .parseFromString(xml, "text/xml")
        .documentElement.getAttribute("schemaVersion");
      if (!supportedSchemaVersions.includes(this.dccSchemaVersion)) {
        this.$logger.error(
          "Schema version " + this.dccSchemaVersion + " not supported."
        );
        this.unsupportedSchemaVersionDialog = true;
        this.$global.loadingDcc = false;
        return;
      }
      // validate xml if it is not an auto-saved item
      if (!dccFile.autoSave) {
        if (new Blob([xml]).size > 4000000) {
          // warning that attachments are not validated if DCC file size exceeds 4 MB
          this.$notifier.info(this.$t("tool.noAttachmentValidationWarning"));
        }
        const result = await this.$tool.validationStrategy.validate(xml);
        if (!result.valid) {
          this.errors = result.errors;
          this.errorDialog = true;
          this.$global.loadingDcc = false;
          return;
        }
      }
      const dccDocument = DCCDocument.fromXml(xml);

      // Replace schema location and schema version to the latest version
      if (this.dccSchemaVersion !== latestSchemaVersion) {
        this.$set(
          dccDocument.digitalCalibrationCertificate._attr,
          "xsi:schemaLocation",
          latestSchemaLocation
        );
        this.$set(
          dccDocument.digitalCalibrationCertificate._attr,
          "schemaVersion",
          latestSchemaVersion
        );
        this.$notifier.info(this.$t("tool.schemaUpdateWarning"));
      }

      // load the file into the tool
      this.$tool.emit("dccLoaded", {
        file: dccFile,
        dccDocument,
      });
    },
    async clearLastLoadedFiles() {
      if (!confirm(this.$t("tool.upload.lastLoadedFiles.confirmClear"))) return;
      await this.$tool.storageStrategy.clearLastLoadedItems();
      this.items = [];
    },
    closeErrorDialog() {
      this.errorDialog = false;
      this.unsupportedSchemaVersionDialog = false;
      this.dialog = true;
    },
  },
};
</script>

<style lang="scss" scoped>
pre code {
  border: 1px solid #999;
  padding: 20px;

  &::before {
    content: "";
  }
}
</style>
